ru.bitel.bgbilling.modules.voice.api.common.service

## Interface VoiceGeographicCodeService

-     @MTOM(enabled=true,
            threshold=1024)
      public interface VoiceGeographicCodeService

  Веб-сервис для работы с географическими кодами модуля Voice. Сервис позволяет выводить список кодов в виде дерева, создавать новые/обновлять существующие /удалять/импортировать/экспортирвоать географические коды.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `deleteAllGeographicCode(int operatorId)` Удаление всех географических кодов из БД.
    `int` | `deleteGeographicCode(java.util.List<java.lang.Integer> codes)` Удаление геокода (-ов) из БД.
    `void` | `getGeographicCodeTree(int operatorId, javax.xml.ws.Holder<javax.activation.DataHandler> codes)` Получение дерева географических кодов оператора.
    `java.lang.String` | `importGeographicCode(int operatorId, boolean addNew, boolean updateExist, javax.xml.ws.Holder<javax.activation.DataHandler> importContent)` Импортирование списка географических кодов в БД.
    `int` | `updateGeographicCode(VoiceGeographicCode code)` Добавление нового/обновление существующего географического кода с одновременным обновлением истории геокода.

- - ### Method Detail

    - #### getGeographicCodeTree

          void getGeographicCodeTree(int operatorId,
                                     javax.xml.ws.Holder<javax.activation.DataHandler> codes)
                              throws ru.bitel.bgbilling.common.BGException,
                                     ru.bitel.bgbilling.common.BGMessageException

      Получение дерева географических кодов оператора.
      Parameters:
        `date` - дата, на которую необходимо получить дерево
        `codes` - список кодов в виде дерева, сериализованное в виде json
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### updateGeographicCode

          int updateGeographicCode(VoiceGeographicCode code)
                            throws ru.bitel.bgbilling.common.BGException,
                                   ru.bitel.bgbilling.common.BGMessageException

      Добавление нового/обновление существующего географического кода с одновременным обновлением истории геокода.
      Parameters:
        `code` - экземпляр географического кода.
      Returns:
        код вставленной/обновленой записи.
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### deleteGeographicCode

          int deleteGeographicCode(java.util.List<java.lang.Integer> codes)
                            throws ru.bitel.bgbilling.common.BGException,
                                   ru.bitel.bgbilling.common.BGMessageException

      Удаление геокода (-ов) из БД.
      Parameters:
        `codeId` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### importGeographicCode

          java.lang.String importGeographicCode(int operatorId,
                                                boolean addNew,
                                                boolean updateExist,
                                                javax.xml.ws.Holder<javax.activation.DataHandler> importContent)
                                         throws ru.bitel.bgbilling.common.BGException,
                                                ru.bitel.bgbilling.common.BGMessageException

      Импортирование списка географических кодов в БД.
      Parameters:
        `addNew` - флаг, добавлять ли новые геокоды при отсутствии
        `updateExist` - флаг, обновлять ли существующие
        `period` - период, который выставится у всех геокодов. По умолчанию, если не задано, то с текущего момента и до бесконечности.
        `importContent` - импортируемое содержимое в виде списка строк, каждая из которых разделена на поля
      Returns:
        строка, содержащая список строк, которые не были обработаны по тем или иным причинам. Эта строка отобразится в клиенте
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### deleteAllGeographicCode

          void deleteAllGeographicCode(int operatorId)
                                throws ru.bitel.bgbilling.common.BGException,
                                       ru.bitel.bgbilling.common.BGMessageException

      Удаление всех географических кодов из БД.
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`